#include "types.h"

typedef struct Kernel_Params {
  TYPE* d_au , * d_bu ;
  TYPE* d_ad , * d_bd ;
  TYPE* d_Gu , * d_Gd ;
  //Used with REG 
  TYPE* d_expRu_global;
  TYPE* d_expRd_global;
  //Used With MC 
  TYPE* d_expR_global_MC;
  TYPE* d_diagu;
  TYPE* d_diagd ;
  int*  d_pS ;
  float *d_random_numbers;
  int	random_numbers_count;
  int* d_block_sizes; // Save suggested block sizes.
  // Added, not originally in the Kernel params.
  int Nc;
  int L;
  TYPE alpha;
  int ISIZE;
  int GSIZE;
  int nDelays;
  //mc_kernel related params
  int nTimes; // Number of times we will sweep over the ising decoupling field.	
  void* d_devStates ;
  int*  d_ind;//Used to save the value of ind in the global memory

  int ntr; // How many MC sweps before MC_Update needs to call a clean REG. 
  int sgn; // current  sugn of the determinant.

  TYPE beta;
} Kernel_Params;
