#include "Timer.h"

Timer::Timer() {
  cudaEventCreate(&start_Evants);
  cudaEventCreate(&stop_Events);
    
  Total_GPU = 0.0;
  Total_OS  = 0.0;

  elapsedTime_GPU = 0;
  elapsedTime_OS  = 0;
}
 
Timer::~Timer() {
  cudaEventDestroy(start_Evants);
  cudaEventDestroy(stop_Events);
} 

void Timer::Start() {
  elapsedTime_GPU = -1;
  elapsedTime_OS  = -1;
  cudaEventRecord(start_Evants, 0) ;
  Begin  = clock_now();
}

double Timer::clock_now() {
    struct timeval now;
    gettimeofday(&now, NULL);
    return (double)now.tv_sec + (double)now.tv_usec/1.0e6;
}

void Timer::Reset() {            
  elapsedTime_GPU = 0;
  elapsedTime_OS  = 0;
  Total_GPU = 0 ;
  Total_OS  = 0 ;
}
  
void Timer::Stop() {
  //check the best practices guide for details of timings.
  cudaEventRecord(stop_Events, 0);
  cudaEventSynchronize(stop_Events);
  Finish = clock_now();

  cudaEventElapsedTime(&elapsedTime_GPU, start_Evants, stop_Events);
  elapsedTime_GPU =  elapsedTime_GPU/1000;
  elapsedTime_OS  = (Finish - Begin);

  Total_GPU += elapsedTime_GPU;//cudaEventElapsedTime returns time in ms
  Total_OS  += (elapsedTime_OS);
}
