        
!-----------------------------------------------------------
!reg delayed kernel with printing
	subroutine reg_delayed_cuda_debugging

        use Global
        implicit none
        include 'mpif.h'

	integer m,n,k,jc,ic, ind, imd,gind
	real*8 :: guf(1:(Nt*Nt)), gdf(1:(Nt*Nt))


	do m=1,nl
        do n=1,nl 
          k=n-m
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
!	  gind = imd + Nc*nl*(ind -1)
	  gind = ind + Nc*nl*(imd -1) ! This is reversed from the original
!	  version
          gu(ind,imd)=Gcst_not(k,ic,jc) !! we can just copy to guf. 
	  guf(gind) = gu(ind,imd)
          gd(ind,imd)=Gcst_not(k,ic,jc) !! we can just copy to gdf directly. 
	  gdf(gind) = gd(ind,imd)
        
        end do
        end do
        end do
        end do

	write(*,*) "Calling CUDA routine (testLinking.f)"
	call CALLCUDA(guf,gdf,s,Nc,nl,Nblock,alpha,umode)

	write(*,*) "And we are back from C (from fortran)"

	do m=1,nl
        do n=1,nl
          
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
!	  gind = imd + Nc*nl*(ind -1)
	  gind = ind + Nc*nl*(imd -1)  !This is reversed form original version
	  gu(ind,imd) = guf(gind)
	  gd(ind,imd) = gdf(gind)

        end do
        end do
        end do
        end do

        end subroutine

!-------------------------------------------------------------
!reg delayed kernel
        subroutine reg_delayed_cuda

        use Global
        implicit none
        include 'mpif.h'

	integer m,n,k,jc,ic, ind, imd,gind
	real*8 :: guf(1:(Nt*Nt)), gdf(1:(Nt*Nt))


	do m=1,nl
        do n=1,nl 
          k=n-m
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
	  gind = ind + Nc*nl*(imd -1)
          gu(ind,imd)=Gcst_not(k,ic,jc)
	  guf(gind) = gu(ind,imd)
         gd(ind,imd)=Gcst_not(k,ic,jc)
	  gdf(gind) = gd(ind,imd)

        end do
        end do
        end do
        end do


	call CALLCUDA(guf,gdf,s,Nc,nl,Nblock,alpha,umode)


	do m=1,nl
        do n=1,nl
          
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
	  gind = ind + Nc*nl*(imd -1)
	  gu(ind,imd) = guf(gind)
	  gd(ind,imd) = gdf(gind)

        end do
        end do
        end do
        end do

        end subroutine

!------------------------------------
! MC update kernel
        subroutine update_delayed_cuda(ntimes)

        use Global
        implicit none
        include 'mpif.h'
        integer ntimes
	integer m,n,jc,ic, ind, imd,gind
	real*8 :: guf(1:(Nt*Nt)), gdf(1:(Nt*Nt))

	do m=1,nl
        do n=1,nl
          
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
!	  gind = imd + Nc*nl*(ind -1)
	  gind = ind + Nc*nl*(imd -1) ! This is reversed from the original
	  guf(gind) = gu(ind,imd)
	  gdf(gind) = gd(ind,imd)

        end do
        end do
        end do
        end do

 !       call copySpringNumbersToGPU 
        !100 random numbers from spring copied
        !copied to springRs_device to use
	call CALLUPDATECUDA(guf,gdf,s,Nc,nl,Nblock,ntimes,alpha,sgn,umode)


	do m=1,nl
        do n=1,nl
          
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
!	  gind = imd + Nc*nl*(ind -1)
	  gind = ind + Nc*nl*(imd -1) ! This is reversed from the original
	  gu(ind,imd) = guf(gind)
	  gd(ind,imd) = gdf(gind)

        end do
        end do
        end do
        end do

        end subroutine

!!!!!!!!!!!!!!!!!!!!!!!1
!Call cuda meas routine
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        subroutine cudaMeas
        
        use Global
        implicit none
	integer m,n,jc,ic, ind, imd,gind
	real*8 :: guf(1:(Nt*Nt)), gdf(1:(Nt*Nt))
	
        do m=1,nl
        do n=1,nl
          
        do jc=1,Nc
        do ic=1,Nc
          ind=ic + (n-1)*Nc
          imd=jc + (m-1)*Nc
	  gind = ind + Nc*nl*(imd -1) ! This is reversed from the original
	  guf(gind) = gu(ind,imd)
	  gdf(gind) = gd(ind,imd)

        end do
        end do
        end do
        end do
        
                call CALLMEASCUDA(guf,gdf,s,beta) 
        
        end subroutine

!
!Below is for testing the sprgn random numbers on cuda
!
        subroutine copySpringNumbersToGPU

        use Global
        implicit none
        include 'mpif.h'
#define SIMPLE_SPRNG
#define FLOAT_GEN
#define USE_MPI
#include "sprng_f.h" 
        integer numberToCopy, i 
        real*8 rands(1:100)

        numberToCopy = 100

        do i=1,numberToCopy

                rands(i) = sprng()
        end do

        call COPYSPRINGNUMBERS(rands,numberToCopy)


        end subroutine 
