__device__ float getRadomNumber(curandState_t* state) {
  return curand_uniform(state);
}

__device__ __forceinline__ int getIndex2d(int RowIdx, int ColIdx , int RowSize , int ColSize) {
  #ifdef __COL__MAJOR__  //Col Major.
    return ColIdx*ColSize + RowIdx;
  #else      //Row Major.
    return RowIdx*RowSize + ColIdx;
  #endif
}
__device__ __forceinline__ int FlattenIdx(int RowIdx, int ColIdx , int RowSize , int ColSize) {
  #ifdef __COL__MAJOR__  //Col Major.
    return ColIdx*ColSize + RowIdx;
  #else      //Row Major.
    return RowIdx*RowSize + ColIdx;
  #endif
}

__device__ __forceinline__ TYPE GetG(TYPE* pG, int row , int col, int ISIZE) {
  return pG[getIndex2d(row,col,ISIZE,ISIZE)];
};

__device__ __forceinline__ void  CublasFromDevice(TYPE* a, TYPE* b, TYPE* c, int M, int N, cublasHandle_t handle) {
  TYPE f_Alpha = 1.0f;
  TYPE f_Beta  = 1.0f;
  cublasStatus_t status;
  #ifdef _SINGLE_
  status = cublasSgemm(handle,
      CUBLAS_OP_N,
      CUBLAS_OP_N,
      M,  
      M,  
      N,  
      &f_Alpha,
      a,
      M,  
      b,
      N,  
      &f_Beta,
      c,
      M);
  #else
  status = cublasDgemm(handle,
      CUBLAS_OP_N,
      CUBLAS_OP_N,
      M,  
      M,  
      N,  
      &f_Alpha,
      a,
      M,  
      b,
      N,  
      &f_Beta,
      c,
      M);
  #endif
  if(status != CUBLAS_STATUS_SUCCESS) {
    printf("Multiplication failed with error %i\n", status);
  }
}

