        subroutine ginit
c*********************************************************************
c       This subroutine makes the initial greens functions, ie. those
c       when all s=+1 or with s taken from a prior run.  It starts 
c       with Gcst_not, the greens function calculated by geod and 
c       corresponding to all s=0 and V_ic=V(ic), and then uses reg to 
c       form the desired result.  ginit also initializes many arrays
c       and the HHS field configuration.
c*********************************************************************
        use Global
	use debug
        use pTiming
        implicit none
        include 'mpif.h'
c************************************************************ 
        integer i,j
c************************************************************
        character(len=1024) :: filename
c       initialize the fields
        if(iter.eq.1.and.isf.eq.0) then
          s=1
          sgn=oner
        else
c         use the field configuration from the last run or that
c         was readin from sigma.dat (if isf=1).
          if(myrank.eq.0) write(lud,*) 'initialized with old field'
        end if
c       Now make the initial green funciton

	if (umode .eq. 4 ) then
		call reg 
		write (filename,"((A,I2.2))") "afterREG_cuda_iter_", iter
		call printGuAndGd(filename)	
!		call reg
!		write (filename,"((A,I2.2))") "afterREG_fortran(umode4)_iter_", iter
!		call printGuAndGd(filename)
	else
                        reg_start = MPI_WTIME()
		call reg
                        reg_end = MPI_WTIME()
                        print *, "TIME FOR whole REG in ginit:", reg_end - reg_start 
		write (filename,"((A,I2.2))") "afterREG_fortran_iter_", iter
		call printGuAndGd(filename)
	end if
 	
c       Initialize some variables and accumulators
        acrat=zeror
        acount=zeror
        ucount=zeror
        nslr=0
        sgnf=zeror
        sgnfs=zeror
        sgnm=zeror
        moom=zeror
        moof=zeror
        moofs=zeror
        mooft=zeror

        gf(:,:)=zeror
        gft(:,:)=zeror
        gfs(:,:)=zeror
        gmeas(:,:)=zeror

        chf(:,:)=zeror
        chft(:,:)=zeror
        chfs(:,:)=zeror
        chmeas(:,:)=zeror

        scf(:,:)=zeror
        scft(:,:)=zeror
        scfs(:,:)=zeror
        scmeas(:,:)=zeror

        ccf(:,:)=zeror
        ccft(:,:)=zeror
        ccfs(:,:)=zeror
        ccmeas(:,:)=zeror
        b1gmeas(:,:)=zeror
        b2gmeas(:,:)=zeror

        chaf(:,:)=zeror
        chaft(:,:)=zeror
        chafs(:,:)=zeror
        cham(:,:)=zeror

        autosgn(:)=zeror
        autodat(:)=zeror

        sus_kkt(:) = zeror
        sus_kdt(:) = zeror
        sus_ddt(:) = zeror
        sus_eet(:) = zeror
        bow_meas   = zeror
        dbop_meas  = zeror
        chiRVB_tau(:,:) = zeror
        chiRVB0(:) = zeroc
        chiBOW_tau(:,:) = zeror
        chiBOW0(:) = zeroc
        chizz_tau(:,:) = zeror
        chizz0(:) = zeroc
        chiss_tau(:,:) = zeror
        chiss0(:) = zeroc


        RVB1(:) = zeror
        RVB0 = zeror
        RVB1d(:) = zeror
        RVB0d = zeror
        RVB1xx(:) = zeror
        RVB0xx = zeror
        AFM1(:) = zeror
        AFM0 = zeror


        RVBchixxm(:,:) = zeror
        RVBchixxt(:,:) = zeror
        RVBchixym(:,:) = zeror
        RVBchixyt(:,:) = zeror
        ChiHHSm(:,:) = zeror
        ChiHHSt(:,:) = zeror

        BB1(:) = zeror
        BBp1(:) = zeror
        BBp2(:) = zeror
        BBp3(:) = zeror
        BB0 = zeror


        if(isg.eq.1) then
          gamatcenter(:,:)=zeroc
          gamatscenter(:,:)=zeroc
          gamatccenter(:,:)=zeroc
          gamatcorner(:,:)=zeroc
          gamatscorner(:,:)=zeroc
          gamatccorner(:,:)=zeroc
          gamatc0center(:)=zeroc
          gamatc0corner(:)=zeroc
        end if
        if(myrank.eq.0.and.iprint.ge.9) then 
           write(lud,*) 'done ginit';flush(lud)        !0
        endif

        return
        end
