extern "C" void launch_reg_blocked(Kernel_Params*);

__device__ void init_matrix( int global_idx, 
                             int block_size, 
                             TYPE Mu[BLOCK][BLOCK], 
                             TYPE Md[BLOCK][BLOCK]) {
  if (global_idx == 0) {
    Md[0][0] = 1;
    Md[0][1] = 4;
    Md[0][2] = -3;

    Md[1][0] = -2;
    Md[1][1] = 8;
    Md[1][2] = 5;

    Md[2][0] = 3;
    Md[2][1] = 4;
    Md[2][2] = 7;
   ///////////// 
    Mu[0][0] = 1;
    Mu[0][1] = 4;
    Mu[0][2] = -3;
    
    Mu[1][0] = -2;
    Mu[1][1] = 8;
    Mu[1][2] = 5;
    
    Mu[2][0] = 3;
    Mu[2][1] = 4;
    Mu[2][2] = 7;
  }
};
 
__device__ void init_matrix_3( int global_idx, 
                             int block_size, 
                             TYPE Mu[BLOCK][BLOCK], 
                             TYPE Md[BLOCK][BLOCK]) {
  if (global_idx == 0) {
    printf ("Hello, I am thread 0 y'all\n");
    Mu[0][0] = 4;
    Mu[0][1] = 4;
    Mu[0][2] = 4;
    Mu[0][3] = 4;

    Mu[1][0] = 4;
    Mu[1][1] = 4;
    Mu[1][2] = 4;
    Mu[1][3] = 4;

    Mu[2][0] = 4;
    Mu[2][1] = 4;
    Mu[2][2] = 4;
    Mu[2][3] = 4;
   
    Mu[3][0] = 4;
    Mu[3][1] = 4;
    Mu[3][2] = 4;
    Mu[3][3] = 4;
   ///////////// 
   ///////////// 
    Md[0][0] = 4;
    Md[0][1] = 4;
    Md[0][2] = 4;
    Md[0][3] = 4;

    Md[1][0] = 4;
    Md[1][1] = 4;
    Md[1][2] = 4;
    Md[1][3] = 4;

    Md[2][0] = 4;
    Md[2][1] = 4;
    Md[2][2] = 4;
    Md[2][3] = 4;
   
    Md[3][0] = 4;
    Md[3][1] = 4;
    Md[3][2] = 4;
    Md[3][3] = 4;
    
  }
};
__device__ void init_matrix_2( int global_idx, 
                               int block_size, 
                               TYPE Mu[BLOCK][BLOCK], 
                               TYPE Md[BLOCK][BLOCK]) {
  if (global_idx == 0) {
    printf ("Hello, I am thread 0 y'all\n");
  
    Md[0][0] = 25;
    Md[0][1] = 5;
    Md[0][2] = 1;

    Md[1][0] = 64;
    Md[1][1] = 8;
    Md[1][2] = 1;

    Md[2][0] = 144;
    Md[2][1] = 12;
    Md[2][2] = 1;
//////////////////////
    Mu[0][0] = 25;
    Mu[0][1] = 5;
    Mu[0][2] = 1;
  
    Mu[1][0] = 64;
    Mu[1][1] = 8;
    Mu[1][2] = 1;
    
    Mu[2][0] = 144;
    Mu[2][1] = 12;
    Mu[2][2] = 1;
  }
};

// The test case I am using to check for correcness: 
// M = 1  4 -3 
//    -2  8  5 
//     3  7  4 

// U = 1  4  -3 
//     0  16 -1
//     0  0  15.5 

// L =  1   0   0 
//     -2   1   0
//      3 -0.5  1

//Determinant = 1*16*15.5 = 248. 
__device__ void print_matrix(int global_idx, int block_size, TYPE Lu[BLOCK][BLOCK]) {
  if (global_idx == 0) {
    printf("[");
    for (int row = 0; row < block_size; row++) {
      printf("[");
      for (int col = 0; col < block_size; col++) {
        if (col ==0) {
          printf("%f ", Lu[row][col]); }
        else {
          printf(",%f ", Lu[row][col]); }
         
      }
    printf("],\n");
   }
   printf("]\n");
  }
}
 
__device__ void 
print_g(int global_idx, TYPE* G, int ISIZE) {
  if(global_idx ==0) {
    for(int row = 0; row < ISIZE; row ++) {
      for(int col = 0; col < ISIZE; col++) {
        printf("%f ", GetG(G, row, col, ISIZE));
      }
      printf("\n");
    }
  } 
}


__forceinline__
__device__ void 
assemble_b_reg_blocked(int global_idx, int num_threads, int ind_start, int block_size, int ISIZE, TYPE* bu,TYPE* bd, TYPE* Gu, TYPE* Gd) {

// Only use one block Index for building the B.
  if (block_size < 32) {
    for (int col = 0; col < block_size; col++) {
      for (int row = global_idx; row < ISIZE; row += num_threads) {
        int b_idx  = FlattenIdx(row, col, block_size, ISIZE);
        bu[b_idx]  = GetG(Gu, row, ind_start + col, ISIZE);
        bd[b_idx]  = GetG(Gd, row, ind_start + col, ISIZE);
        // TODO: Check with conrad, why are we doing this !!!
        // This is correct; B = (G - I)[ISIZE, Nblock] so we must 
        // subtract 1 from the diagonal elements !
        if(ind_start + col == row) {
          bu[b_idx] -=1;
          bd[b_idx] -=1;
        }
      }
    }
  } else {
    for (int row = 0; row < ISIZE; row ++) {
       for (int col = global_idx; col < block_size; col += block_size) {
        int b_idx  = FlattenIdx(row, col, block_size, ISIZE);
        bu[b_idx]  = GetG(Gu, row, ind_start + col, ISIZE);
        bd[b_idx]  = GetG(Gd, row, ind_start + col, ISIZE);
        // TODO: Check with conrad, why are we doing this !!!
        // This is correct; B = (G - I)[ISIZE, Nblock] so we must 
        // subtract 1 from the diagonal elements !
        if(ind_start + col == row) {
          bu[b_idx] -=1;
          bd[b_idx] -=1;
        }
      }
    }
  }
}




// LU factorization without Pivoting, the doolittle agorithm.
__forceinline__ 
__device__ 
void factorize(int global_idx, 
               int block_size,
               TYPE Lu[BLOCK][BLOCK],
            //   TYPE Ld[BLOCK][BLOCK],
               TYPE Mu[BLOCK][BLOCK],
            //   TYPE Md[BLOCK][BLOCK],
            //   TYPE& determinant_d,
               TYPE& determinant_u) {
  if (global_idx < 32) {
    //determinant_d = 1;
    determinant_u = 1;

    if (global_idx < block_size) {
      for (int step = 0; step < block_size; step++) {
        for (int working_row = step + 1; working_row < block_size; working_row++) {
	  // workig row is the row we are 
          const TYPE ratio_u = Mu[working_row][step] / Mu[step][step];
          //const TYPE ratio_d = Md[working_row][step] / Md[step][step];
          // Now update the working row
          Mu[working_row][global_idx] += -1*ratio_u*Mu[step][global_idx];
          //Md[working_row][global_idx] += -1*ratio_d*Md[step][global_idx];
          // Now update the lower diagonal Matrix
          // Note that I am avoiding updaing the elements that shouls stay zeros.
          // this will affect the sign for very small numbers.
          if (step==global_idx) { 
            Lu[working_row][step] = 1*ratio_u*Lu[step][step];
            //Ld[working_row][step] = 1*ratio_d*Ld[step][step];
          }
         } 
        //determinant_d *= Md[step][step];
        determinant_u *= Mu[step][step];        
      }
    }
  }
}

// LU factorization with pivoting
__forceinline__
 __device__ 
void factorize_pivoting(int global_idx, 
                        const int block_size,
                        TYPE Lu[BLOCK][BLOCK], 
                        TYPE Ld[BLOCK][BLOCK], 
                        TYPE Mu[BLOCK][BLOCK], 
                        TYPE Md[BLOCK][BLOCK],
                        TYPE tmp[BLOCK], 
                        TYPE& determinant_d, 
                        TYPE& determinant_u) {
  
  if (global_idx < 32) {
    determinant_d = 1;
    determinant_u = 1;

    if (global_idx < block_size) {
      for (int step = 0; step < block_size; step++) {
        if (global_idx == 0) {
          printf("before reordering in step Mu = %i\n", step);
          print_matrix(global_idx, block_size, Mu);
        
          printf("before reordering in step Lu = %i\n", step);
          print_matrix(global_idx, block_size, Lu);
        }
        // Find the max possible pivot and reorder the rows accordingly (Partial pivoting).
        const int src_row = step;
        // Where the pivot row is (row with the maximum element for pivoting)i
        int pivot_row_up   = step;
        int pivot_row_down = step;
     
        for (int search_row = step + 1; search_row < block_size; search_row++) {
          if (Mu[search_row][step] > Mu[pivot_row_up][step]) {
           pivot_row_up = search_row;
          }
          if (Md[search_row][step] > Md[pivot_row_down][step]) {
           pivot_row_down = search_row;
          }
        }
  
        // Now actually interchange the rows:
        if (pivot_row_up != src_row) {
          // Exchange the M rows
          if (global_idx == 0) {
            printf("exchanging row %i and row %i for Up\n", src_row, pivot_row_up);
          }
          tmp[global_idx] = Mu[src_row][global_idx];
          Mu[src_row][global_idx]  = Mu[pivot_row_up][global_idx];
          Mu[pivot_row_up][global_idx] = tmp[global_idx];
          // Now exchange the L rows.
          if (global_idx < step - 1) { // Dont flip any thing eyond the diagonal.
            tmp[global_idx] = Lu[src_row][global_idx];
            Lu[src_row][global_idx]  = Lu[pivot_row_up][global_idx];
            Lu[pivot_row_up][global_idx] = tmp[global_idx];
          }
          determinant_u *= -1;
	}

        if (pivot_row_down != src_row) {
        // Must exchange !!
          //if (global_idx == 0) {
          //  printf("exchanging row %i and row %i for Down\n", src_row, pivot_row_down);
          //}
          tmp[global_idx] = Md[src_row][global_idx];
          Md[src_row][global_idx]  = Md[pivot_row_down][global_idx];
          Md[pivot_row_down][global_idx] = tmp[global_idx];
  
          if (global_idx < step - 1) { // Dont flip any thing eyond the diagonal.
            tmp[global_idx] = Ld[src_row][global_idx];
            Ld[src_row][global_idx]  = Ld[pivot_row_down][global_idx];
            Ld[pivot_row_down][global_idx] = tmp[global_idx];
          }
          determinant_d *= -1;
	}

        //  Done reordering rows, print M to trace correctness
        if (global_idx == 0) {
          printf("After reordering in step Mu = %i\n", step);
          print_matrix(global_idx, block_size, Mu);
        
          printf("After reordering in step Lu = %i\n", step);
          print_matrix(global_idx, block_size, Lu);
        }
        
        for (int working_row = step + 1; working_row < block_size; working_row++) {
	  // workig row is the row we are 
          const TYPE ratio = Mu[working_row][step] / Mu[step][step];
          // Now update the working row
          Mu[working_row][global_idx] += -1*ratio*Mu[step][global_idx];
          Md[working_row][global_idx] += -1*ratio*Md[step][global_idx];
          // Now update the lower diagonal Matrix
          // Note that I am avoiding updaing the elements that should stay zeros.
          // this will affect the sign for very small numbers.
          if (step==global_idx) { 
            Lu[working_row][step] = 1*ratio*Lu[step][step];
            Ld[working_row][step] = 1*ratio*Ld[step][step];
          }
         } 
          determinant_d *= Md[step][step];
          determinant_u *= Mu[step][step];        
      }
    }
  }

   if (global_idx == 0) {
      printf("Beofre exiting factorization Mu:\n");
      print_matrix(global_idx, block_size, Mu);      
      printf("Before exiting factorization Lu:\n");
      print_matrix(global_idx, block_size, Lu);
    }
}




__forceinline__
 __device__ 
void _factorize_pivoting(int global_idx, 
                        const int block_size,
                        TYPE Lu[BLOCK][BLOCK], 
                        TYPE Mu[BLOCK][BLOCK], 
                        TYPE tmp[BLOCK], 
                        TYPE& determinant_u) {
//  if (global_idx < 32) {
    determinant_u = 1;
    if (global_idx < block_size) {
      for (int step = 0; step < block_size; step++) {
        // Find the max possible pivot and reorder the rows accordingly (Partial pivoting).
        const int src_row = step;
        // Where the pivot row is (row with the maximum element for pivoting)i
        int pivot_row_up   = step;
        for (int search_row = step + 1; search_row < block_size; search_row++) {
          if (Mu[search_row][step] > Mu[pivot_row_up][step]) {
           pivot_row_up = search_row;
          }
        }
        //__syncthreads();
        // Now actually interchange the rows:
        if (pivot_row_up != src_row) {
          // Exchange the M rows
          tmp[global_idx] = Mu[src_row][global_idx];
          Mu[src_row][global_idx]  = Mu[pivot_row_up][global_idx];
          Mu[pivot_row_up][global_idx] = tmp[global_idx];
          // Now exchange the L rows.
          if (global_idx < step - 1) { // Dont flip any thing eyond the diagonal.
            tmp[global_idx] = Lu[src_row][global_idx];
            Lu[src_row][global_idx]  = Lu[pivot_row_up][global_idx];
            Lu[pivot_row_up][global_idx] = tmp[global_idx];
          }
          determinant_u *= -1;
	}
       // __syncthreads();
        //  Done reordering rows, print M to trace correctness
        for (int working_row = step + 1; working_row < block_size; working_row++) {
	  // workig row is the row we are 
          const TYPE ratio = Mu[working_row][step] / Mu[step][step];
          // Now update the working row
          Mu[working_row][global_idx] += -1*ratio*Mu[step][global_idx];
          // Now update the lower diagonal Matrix
          // Note that I am avoiding updaing the elements that should stay zeros.
          // this will affect the sign for very small numbers.
          if (step==global_idx) {
            Lu[working_row][step] = 1*ratio*Lu[step][step];
          }
         //__syncthreads();
         }
          determinant_u *= Mu[step][step];        
      }
    }
//  }
}



__forceinline__
__device__
TYPE I(int row, int col) {
 return (row == col) ? 1.0 :0.0;
}

// LU factorization without Pivoting, the doolittle agorithm.
__forceinline__ 
__device__ 
void find_inverse(int global_idx, 
                  int block_size,
                  TYPE L[BLOCK][BLOCK],
                  TYPE U[BLOCK][BLOCK],
                  TYPE Z[BLOCK][BLOCK],  
                  TYPE B[BLOCK][BLOCK]) { // save the inverse here.

 if (global_idx < block_size) {
    TYPE accum = 0;
    const int num_steps = block_size; 
    // Forward substitution to solve LZ = I.
    // Lower   Z(U*B)
    //  l 0 0 | z z z     1 0 0 
    //  l l 0 | z z z  =  0 1 0
    //  l l l | z z z     0 0 1

    //Initialize Z to zeros:
    for (int row = 0; row < block_size; row++) {
       Z[row][global_idx] = 0.0;
       B[row][global_idx] = 0.0;
    }
  
    for (int step = 0; step < num_steps; step++) {
      //__syncthreads();
      // We will process all the colums at the same time instead of 
      // doing them one by one.    
      accum = 0;
      for (int col = 0; col < step; col++ ) {
        accum += L[step][col]*Z[col][global_idx];
      }
        Z[step][global_idx] = I(step, global_idx) - accum;
    } // for (int step
  }

   //REMEBER: NO SYNCTHREADS INSIDE AN IF_BLOCK THAT CAUSES EXECUTION DIVERGENCE.
   __syncthreads();
/*
   if(global_idx == 0) {
     printf ("Z =\n");
     for (int row = 0; row < block_size; row++) {
       for (int col = 0; col < block_size; col++) {
         printf("%f   ", Z[row][col] );
       }
       printf("\n");
     }
   }
*/
 if (global_idx < block_size) {
    const int num_steps = block_size; 
     TYPE accum = 0;
      for (int step = num_steps-1; step >= 0; step--) {
        accum = 0;
        for (int col = 0; col < num_steps ; col++) {
          accum += U[step][col]*B[col][global_idx];
        }
        B[step][global_idx] = (Z[step][global_idx] - accum)/U[step][step];
    }
  }   // if (global_idx < block_size)

 //REMEBER: NO SYNCTHREADS INSIDE AN IF_BLOCK THAT CAUSES EXECUTION DIVERGENCE.
  __syncthreads();
}

__device__
__forceinline__
void build_a(TYPE  M_inv[BLOCK][BLOCK], 
         int ind_start,
         TYPE* a,  
         TYPE* G, 
         //TYPE A_Tile[5][256 + 1], 
         int block_size,
         int ISIZE, 
         int global_idx) {
//  const int num_threas = 32*16;
//  const int tile_width = 256;
//  const int tile_height= 5;

// const int thread_col = global_idx % tile_width;
// const int thread_row = global_idx / tile_width;

  const int thread_col = threadIdx.x;
  const int thread_row = threadIdx.y;

//  if (global_idx ==0) {
//    printf ("blockDim.y = %i\n", blockDim.y);
//    printf ("blockDim.x = %i\n", blockDim.x);
//  }

//  if (threadIdx.y==2) {
//    printf ("threadIdx.x = %i \n", threadIdx.x);
//    printf ("threadIdx.y = %i \n", threadIdx.y);
//  }

/*
  for (int col = thread_col; col < ISIZE ; col += blockDim.x) {
      const int a_idx = FlattenIdx(thread_row, col, ISIZE, block_size);
      TYPE val = -100; 
      for (int i = 0; i < block_size; i++) {
        val += M_inv[thread_row][i]*GetG(G, i + ind_start, col, ISIZE);
      }
      a[a_idx] = val;
  }
*/

  if(threadIdx.y ==0) {
  for (int col = threadIdx.x + blockDim.x * blockIdx.x; col < ISIZE ; col += blockDim.x*gridDim.x) {
    for (int row = threadIdx.y; row < block_size; row += 1) {
      TYPE val = 0; 
      const int a_idx = FlattenIdx(row, col, ISIZE, block_size);
      //printf ("Now computing (%i,%i)\n", row , col);
      for (int i = 0; i < block_size; i++) {
        val += M_inv[row][i]*GetG(G, i + ind_start, col, ISIZE);
      }
      a[a_idx] = val;
    }
  }
}

/*
  // Non tiled vresion of the multiplication:
  for (int col = global_idx; col < ISIZE; col += num_threads) {  
    for (int row = 0; row < block_size; row++) { 
      const int a_idx = FlattenIdx(row, global_idx, ISIZE, block_size);
      
    }
  }

  
 for (int outer_col = global_idx; outer_col < ISIZE; outer_col += tile_size)
  for (int col = global_idx; col < ISIZE; col += 1024) {
    // Read from Gu to the tile (A_Tile).
    for (int row = 0; row < block_size; row++) {
       if (global_idx < tile_size) {    
         //GetG(Gu, x, y, Nc*L)*d_expu[pS[x]];
         A_Tile[row][global_idx] = GetG(G,row, col, Nc*L)
       }      
    }

    // Multiply in shared memory. 
    for (int a_row = 0; a_row < block_size; a_row++) {
      TYPE res = 0;
      for (int m_col = 0; m_col < block_size; m_col++) {
        res += M_inv[a_row][m_col] * A_Tile[m_col][global_idx];
      }   
      int idx =  FlattenIdx(a_row, global_idx, block_size, ISIZE);
      // Write back to Global memory.
      a[idx] = res;
    }
  }
*/
}

 __device__
 __forceinline__
 void  print_b(TYPE* b, int Nc, int L, int global_idx, int block_size) {
  if (global_idx == 0 )
    for (int row = 0; row < Nc*L; row++) {
      for (int col = 0; col < block_size;  col++) {
        int idx =  FlattenIdx(row, col, block_size, Nc*L);
        printf("%f ", b[idx]);
     }
      printf("\n");
    }
 }

__device__
__forceinline__
void print_a(TYPE* a, int NC, int L, int global_idx, int block_size) {
 if (global_idx == 0) 
  for (int row = 0; row < block_size; row++) {
    for (int col = 0; col < NC*L;  col++) { 
      int idx =  FlattenIdx(row, col, NC*L, block_size);
      printf("%f ", a[idx]);
    }   
    printf("\n");
  }
}

__global__ void reg_blocked(int ind_start, TYPE* Gu, TYPE* Gd , int* pS, TYPE* au, TYPE* bu,
 TYPE* ad,TYPE* bd ,TYPE* d_expRu_Global, TYPE* d_expRd_Global, TYPE* d_diagu , TYPE* d_diagd,
 TYPE alpha , int Nc , int L, int block_size) {
  // block size is same as number of delays
  // int ind;
  // const int block_size = 3;
  const int c_max_block_size = 4;

  __shared__ TYPE Mu[BLOCK][BLOCK];
  __shared__ TYPE Md[BLOCK][BLOCK];
  __shared__ TYPE Mu_inv[BLOCK][BLOCK];
  __shared__ TYPE Md_inv[BLOCK][BLOCK];

  __shared__ TYPE clean_block_u[BLOCK][BLOCK];
  __shared__ TYPE clean_block_d[BLOCK][BLOCK];

  //__shared__ TYPE exp_diagonal[c_max_block_size];

  __shared__ TYPE tmp[BLOCK];
  // The lower triangular matrices.
  __shared__ TYPE Lu[BLOCK][BLOCK];
  __shared__ TYPE Ld[BLOCK][BLOCK];
  __shared__ TYPE    Z[BLOCK][BLOCK];
  __shared__ TYPE determinant_d , determinant_u;


 // Tiles for Multiplication: 
 // __shared__ TYPE Au_Tile[c_max_block_size][256+1];
 // __shared__ TYPE Ad_Tile[c_max_block_size][256+1];

  TYPE* d_expu  = d_expRu_Global + 1;
  TYPE* d_expd  = d_expRd_Global + 1;

  const int global_idx  = threadIdx.x; //threadIdx.y * blockDim.x + threadIdx.x;
  const int num_threads = blockDim.x * blockDim.y;
 
//  if (global_idx ==0) {
//    printf("num_threads = %i\n", num_threads);
//    printf("from device: ind_start = %i\n", ind_start);
//    printf("blockDim.x = %i, blockDim.y = %i\n", blockDim.x, blockDim.y);
//    printf ("Gu = \n");
//    print_g(global_idx, Gu, Nc*L);
//    printf ("Gd = \n");
//    print_g(global_idx, Gd, Nc*L);
//  }
  // Launching with 1 thread block that is two dimensional.
  // x and y are used to point to elements that will be read from the green function 
  // (baesd on what ind the simlulation stopped at).

  const int x = threadIdx.x + ind_start;
  // const int y = threadIdx.y + ind_start;

 // Loop over the Ising Field in steps of block_size (outer call to the kenrnel). 
 //  * Build the Mu and Md.
 //  * Find the determinant of Mu and Md.
 //  * Use Mu and Md to build As and Bs. 
 //  * Update the Green Functions with A*B. 


  /* 
  if (threadIdx.x < block_size && threadIdx.y < block_size) {
    Mu[threadIdx.x][threadIdx.y] = -1*GetG(Gu,  x,y, Nc*L)*d_expu[pS[x]];
    Md[threadIdx.x][threadIdx.y] = -1*GetG(Gd,  x,y, Nc*L)*d_expd[pS[x]];

    clean_block_u[threadIdx.x][threadIdx.y] = GetG(Gu, x, y, Nc*L);
    clean_block_d[threadIdx.x][threadIdx.y] = GetG(Gd, x, y, Nc*L);

    // For the diagonal elements:
    if (x==y) {
      Mu[threadIdx.x][threadIdx.y] += 1 + d_expu[pS[x]];
      Md[threadIdx.x][threadIdx.y] += 1 + d_expd[pS[x]];
    }
  }
*/
  for (int col = 0 ; col < block_size; col++)
  if (threadIdx.x < block_size && threadIdx.y < block_size) {
    Mu[threadIdx.x][col] = -1*GetG(Gu,  x, ind_start + col, Nc*L)*d_expu[pS[x]];
    Md[threadIdx.x][col] = -1*GetG(Gd,  x, ind_start + col, Nc*L)*d_expd[pS[x]];

    clean_block_u[threadIdx.x][col] = GetG(Gu, x, col + ind_start, Nc*L);
    clean_block_d[threadIdx.x][col] = GetG(Gd, x, col + ind_start, Nc*L);

    // For the diagonal elements:
    if (x == col + ind_start) {
      Mu[threadIdx.x][col] += 1 + d_expu[pS[x]];
      Md[threadIdx.x][col] += 1 + d_expd[pS[x]];
    }
  }

  for (int col = 0; col < block_size; col++)
  if (threadIdx.x < block_size && threadIdx.y < block_size) {
    if (threadIdx.x == col) {
      // Diagonal elements are ones.
      Lu[col][threadIdx.x] = 1;
      Ld[col][threadIdx.x] = 1;
    } else {
      // Off-diagonal elements
      Lu[col][threadIdx.x] = 0;
      Ld[col][threadIdx.x] = 0;
    }
  }
  

  //init_matrix (global_idx, block_size, Mu, Mu);
  /*  if (global_idx == 0) {
    printf ("Mu is: \n");
    print_matrix(global_idx, block_size, Mu);
    printf ("Md is: \n");
    print_matrix(global_idx, block_size, Md);

    printf ("clean_block_u is: \n");
    print_matrix(global_idx, block_size, clean_block_u);
    printf ("clean_block_d is: \n");
    print_matrix(global_idx, block_size, clean_block_d);
  }
  */


  // Now start the LU factorization.
  // Factorization without pivoting is not stable for small numbers we have in the green 
  // function. 
  __syncthreads();
  _factorize_pivoting(global_idx, block_size, Lu,  Mu, tmp, determinant_u);
  __syncthreads();

  /*
  if (global_idx == 0) {
    printf ("factorized Mu is: \n");
    print_matrix(global_idx, block_size, Mu);
  }
  */
  __syncthreads();

  /*
  if (global_idx == 0) {
    printf ("factorized Lu is: \n");
    print_matrix(global_idx, block_size, Lu);
  }
  */


  _factorize_pivoting(global_idx, block_size, Ld,  Md, tmp, determinant_d);
  //factorize_pivoting(global_idx, block_size, Lu, Mu,  tmp, determinant_u);

 
  __syncthreads();

  /*
  if (global_idx == 0) {
    printf ("factorized Md is: \n");
    print_matrix(global_idx, block_size, Md);
  }

  if (global_idx == 0) {
    printf ("factorized Ld is: \n");
    print_matrix(global_idx, block_size, Ld);
  }
  */

  find_inverse(global_idx, block_size, Lu, Mu, Z, Mu_inv);
  __syncthreads();
  find_inverse(global_idx, block_size, Ld, Md, Z, Md_inv);
 

  /*
  if (global_idx == 0) { 
     printf ("Mu_inv is: \n");
     print_matrix(global_idx, block_size, Mu_inv);
     printf ("Md_Inv is: \n");
     print_matrix(global_idx, block_size, Md_inv);
  }
  */

  // Conrad show me how build the Exp matrix.
  // Just saving the diagonal of the ExpMat matrix.
  //  if (global_idx < block_size)
  //  exp_diagonal[global_idx] = d_expu[pS[ind_start+ global_idx]];

 // Multiply the Exp by the Inverse.    
 // TODO: Ask conrad why I am doing this !!
 // Multiply the whole Mu_inv matrix by the exp value.
 //if (global_idx < block_size) {
 //  Mu_inv[global_idx][global_idx] *= d_expu[pS[ind_start + global_idx]];
 //  Md_inv[global_idx][global_idx] *= d_expd[pS[ind_start + global_idx]];
 //}

  __syncthreads();

  for (int col = 0 ; col < block_size ; col++)
  if (threadIdx.x < block_size && threadIdx.y < block_size) {
//     Mu_inv[threadIdx.x][threadIdx.y] *= d_expu[pS[ind_start + threadIdx.x]];
//     Md_inv[threadIdx.x][threadIdx.y] *= d_expd[pS[ind_start + threadIdx.x]];
//     printf ("Thread (%i,%i)\n", threadIdx.x, threadIdx.y);
     Mu_inv[threadIdx.x][col] *= d_expu[pS[ind_start + threadIdx.x]];
     Md_inv[threadIdx.x][col] *= d_expd[pS[ind_start + threadIdx.x]];
  }

  // We need this __syncthreads 
  __syncthreads();

  /*
   if (global_idx == 0) {
     printf ("Exp * Mu_inv is: \n");
     print_matrix(global_idx, block_size, Mu_inv);
     printf ("Exp * Md_inv is: \n");
     print_matrix(global_idx, block_size, Md_inv);
   }
  */

  // Fill B the dumb way:
  // TYPE GetG(TYPE* pG, int row , int col, int ISIZE) {
  //TODO: This should reconstructed to handle cases where 
  //      ISIZE is less than 
  // if (global_idx < Nc*L)
 
 if (blockIdx.x == 0) {
    assemble_b_reg_blocked(global_idx, num_threads, ind_start, block_size, Nc*L, bu, bd, Gu, Gd);
  }
//  for (int col = 0; col < block_size; col++) {
//   for (int row = global_idx; row < Nc*L; row += num_threads) {
//      int b_idx  = FlattenIdx(row, col, block_size, Nc*L);
//      bu[b_idx]  = GetG(Gu, row, ind_start + col, Nc*L);
//      bd[b_idx]  = GetG(Gd, row, ind_start + col, Nc*L);
//      // TODO: Check with conrad, why are we doing this !!!
//      // This is correct; B = (G - I)[ISIZE, Nblock] so we must 
//      // subtract 1 from the diagonal elements !
//      if(ind_start + col == row) {
//        bu[b_idx] -=1;
//        bd[b_idx] -=1;
//      }
//    }
// }

  __syncthreads();

  
//  if (global_idx  == 0) {
//    printf("Values of bu are: \n");
//    print_b(bu, Nc, L, global_idx, block_size);
//    printf("Values of bd are: \n");
//    print_b(bd, Nc, L, global_idx, block_size);
//  }
  
  //return;

  // print th first 4 cols and 4 rows fro the G
  // Compute the A.
  // Read nBlock Rows from Green function. 
  // Multiply the Rows by the Nblock by Nblock Mu_inv
  // init_matrix_3(global_idx, block_size, Mu_inv, Md_inv);
   __syncthreads();
 //if (blockIdx.x == 0) {
  //  build_a(Mu_inv, ind_start, au, Gu, Au_Tile, block_size, Nc*L, global_idx);
  //  build_a(Md_inv, ind_start, ad, Gd, Ad_Tile, block_size, Nc*L, global_idx);
    build_a(Mu_inv, ind_start, au, Gu, block_size, Nc*L, global_idx);
    build_a(Md_inv, ind_start, ad, Gd, block_size, Nc*L, global_idx);
// }
  __syncthreads();
 
//  if (global_idx == 0) {
//    printf("Values of ad:\n");
//    print_a(ad, Nc, L, global_idx, block_size);
//    printf("Values of au:\n");
//    print_a(au, Nc, L, global_idx, block_size);
//  } 
 
 // __syncthreads();
}


void launch_reg_blocked(Kernel_Params* params) {
  int  ind = 0;
  dim3 thread_block_size;

  thread_block_size.y = 1;//params->nDelays;
 
  if ((params->Nc)*(params->L) > 256) {
    thread_block_size.x = 256/params->nDelays;
    //printf("Launching with :%i threads \n", ThreadsPerBlock_1_Dim);
  } else {
    thread_block_size.x = (params->Nc)*(params->L);
    //printf("Launching with :%i threads \n", ThreadsPerBlock_1_Dim);
  }

  thread_block_size.x = (params->Nc)*(params->L);
  if ((params->Nc)*(params->L) > 256) {
    thread_block_size.x = 256;
  }

  thread_block_size.y = 1;       //params->nDelays;
  int thread_block_count = 14;
  printf("Launching reg_blocked with :%i threads \n", thread_block_size.y * thread_block_size.x);

  cudaGetLastError();  
  CheckCublasError(cublasCreate(&handle), "Creating handle for cublas");
  cudaThreadSynchronize();
  printf("Iteration \t\tKernel_Events \tKernel_Time  \t Sgemm_Events \t sgemm_Time\n");

  Timer KernelTimer;
  Timer SgemmTimer;
  int k;
  for(k = 0; k < (params->Nc)*(params->L) ; k+= params->nDelays) {
    KernelTimer.Start();
    //printf("from host: ind_start = %i\n", ind);
    reg_blocked<<<thread_block_count, thread_block_size>>>(ind,
        		   params->d_Gu, params->d_Gd ,
        		   params->d_pS,
        		   params->d_au, params->d_bu,
        		   params->d_ad, params->d_bd,
        		   params->d_expRu_global,
        		   params->d_expRd_global,
        		   params->d_diagu,
        		   params->d_diagd,
        		   params->alpha, params->Nc, params->L, params->nDelays);

    cudaDeviceSynchronize();
    cutilCheckMsg("reg_blocked_kernel execution failed.\n");
    //continue; 
    KernelTimer.Stop();
    printf(" \t\t %i \t  %2.10f \t  %2.10f ", k/(params->nDelays), KernelTimer.elapsedTime_GPU, KernelTimer.elapsedTime_OS);
    ind += params->nDelays;
    SgemmTimer.Start();
    Multiply_CUBLAS(params->d_bu, params->d_au, params->d_Gu , params);
    Multiply_CUBLAS(params->d_bd, params->d_ad, params->d_Gd , params);
    SgemmTimer.Stop();
    printf("\t %2.10f ",  SgemmTimer.elapsedTime_GPU);
    printf("\t %2.10f \n", SgemmTimer.elapsedTime_OS);
 }

  CheckCublasError(cublasDestroy(handle) , "Destroyig the handle for cublas");  
  printf("\nreg_blocked\n"
        "Block\t\t"
        "Kernel OS:\t\t"
        "Kernel GPU:\t\t"
        "Kernel Overhead:\t"\
        "Sgemm GPU:\t\t"\
        "Sgemm OS:\t\t"\
        "Sgemm Overhead:\t\t"\
        "All:\t\t\n");

  printf("%i\t\t"
        "%2.10f\t\t%2.10f\t\t%2.10f\t\t"
        "%2.10f\t\t%2.10f\t\t%2.10f\t\t"
        "%2.10f"
        "\n-------------------------------------------------------------\n",
        params->nDelays,
        KernelTimer.Total_OS,
        KernelTimer.Total_GPU,
        KernelTimer.Total_OS - KernelTimer.Total_GPU,
        SgemmTimer.Total_GPU,
        SgemmTimer.Total_OS,
        SgemmTimer.Total_OS - SgemmTimer.Total_GPU,
        KernelTimer.Total_OS + SgemmTimer.Total_OS);
//  exit(0);
};
